<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <b-breadcrumb :items="items"></b-breadcrumb>    
            <!-- Mask -->
        </base-header>
        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col">
                    <div class="card shadow">
                        <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                            <h3 class="mb-0">
                                {{title}}
                            </h3>
                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                            </div>
                            <div class="col text-right">
                                <button class="btn btn-lg btn-primary" @click="showCreate = true">Create App</button>
                            </div>
                            <div>
                                <modal :show="showCreate" @close="showCreate = false">
                                    <template slot="header">
                                        <h5 class="modal-title">Create</h5>
                                    </template>
                                    <div>
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="App name"
                                                        placeholder="App name"
                                                        input-classes="form-control-alternative"
                                                        v-model="app_name"
                                            />
                                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                                        </div>
                                    </div>
                                    <template slot="footer">
                                            <base-button type="secondary" @click="showCreate = false">Close</base-button>
                                            <base-button type="primary" @click="checkData">Create</base-button>
                                    </template>
                                </modal>
                            </div>
                        </div>
                        </div>

                        <div class="table-responsive">
                        <table class="table align-items-center table-flush text-center">
                            <tr>
                                <th>No.</th>
                                <th>App name</th>
                                <th>Manage</th>
                            </tr>

                            <tr v-for="(app,index) in tableData" :key="app.app_id" :class="{editing: app == dataEdit}" v-cloak>
                            <td>{{index+1}}</td>
                            <td class="budget">
                                <div class="view">
                                <span>{{app.app_name}}</span>
                                <small @click="goHotel(app.app_id)"><router-link class="text-blue" to="#"> setting hotel</router-link></small>
                                </div>
                                <div class="edit">
                                <base-input alternative=""
                                                        placeholder="App name"
                                                        input-classes="form-control-alternative"
                                                        v-model="app.app_name"
                                />
                                </div>
                            </td>
                            <td>
                                <div class="view">
                                    <span @click="editData(app)"><router-link class="text-primary" to="#"><i class="fas fa-pen"></i> Edit</router-link></span> |  
                                    <span @click="del(app)"><router-link class="text-danger" to="#"><i class="far fa-trash-alt"></i> Delete</router-link></span>
                                </div>
                                <div class="edit">
                                    <span @click="saveEdit(app)"><router-link class="text-success" to="#"><i class="fas fa-save"></i> Save</router-link></span> |  
                                    <span @click="dataEdit = null"><router-link class="text-default" to="#"><i class="far fa-window-close"></i> Cancel</router-link></span>
                                </div>
                            </td>

                            </tr>

                        </table>
                        </div>
                    </div>
                </div>
            </div>
    </div>
</div>
</template>
<script>

  export default {
    name: 'app-name',
    data() {
      return {
        title: 'App name',
        tableData : [],
        message : '',
        error :'',
        app_name : '',
        showCreate : false,
        dataEdit : null,
        items: [
          {
            text: 'Company',
            to: '/topic'
          },
          {
            text: 'App',
            active: true
          }
        ]
      }
    },
    created() {
        this.getData()
        
    },
    methods: {
        getData(){
            this.error = ''
            this.$http.get('/manage/app')
            .then(response => {
                if(!response.data.message){
                    this.tableData = response.data
                }else{
                    this.message = response.data.message
                }
          })
        },
        checkData(){
            if(this.app_name === ''){
                this.error = 'Please enter app name'
            }else{
                this.sendCreate()
            }
        },
        sendCreate(){
            this.$http.post('/manage/app/create',{
                user_id : localStorage.user_id,
                app_name : this.app_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.showCreate = false
                this.app_name = ''
                this.error = ''
                this.getData()
              }else if(response.data.message === 'cant_create'){
                  this.error = 'Can not use this app name !!'
              }else if(response.data.message === 'no_company'){
                  this.$swal({
                    title: "Please create company",
                    text : 'Create a company?',
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                        this.$router.push('/company')
                    }
                })
              }
          })
          .catch(() => this.checkCreateApp())
        },
        checkCreateApp(){
            this.error = 'Create failed!!'
        },
        editData(app){
            this.dataEdit = app
        },
        saveEdit(app){
            this.$swal({
                    title: "Confirm edit app name?",
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/app/edit',{
                            user_id : localStorage.user_id,
                            app_id : app.app_id,
                            app_name : app.app_name
                        })
                        .then(response => {
                            if(response.data.message === 'no_app'){
                                this.checkEditApp()
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Edited!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getData()
                            }
                        })
                        .catch(() => this.checkEditApp())
                    }
                })
        },
        del(app){
                this.$swal({
                    title: "Confirm delete app name!!",
                    icon: "warning",
                    buttons: ['cancel','confirm'],
                    dangerMode: true
                }).then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/app/del',{
                            user_id : localStorage.user_id,
                            app_id : app.app_id
                        })
                        .then(response => {
                            if(response.data.message === 'no_app'){
                                this.error = 'Delete failed!!'
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Deleted!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getData()
                            }
                        })
                        .catch(() => this.error = 'Delete failed!!' )
                    }
                })
        },
        checkEditApp(){
            this.error = 'Edit failed!!'
        },
        goHotel(app_id){
            localStorage.app_id = app_id
            this.$router.push('/hotel')
        }
    },
  };
</script>
<style scoped>
[v-cloak] {
      display: none;
    }
    .edit {
      display: none;
    }
    .editing .edit {
      display: block
    }
    .editing .view {
      display: none;
    }
</style>